#include <stdio.h>
#include <stdlib.h>

#include "AWList.h"

static inline void mfree(void* arg) {
  free(arg);
  arg = NULL;
}

struct st {
        char *str;
};

int main()
{
	AWList *list = AWList_init(NULL);
	AWNode *node = NULL;

	int num[10] = { 0 };
	for (int i = 0; i < 10; ++i) {
		/* num[i] = calloc(1, sizeof(int)); */
		num[i] = i;

		AWList_add_tail(list, &num[i], 0);
	}

	while ((node = AWList_iterator(list))) {
		if (!node)
			break;
                if (!node->data) break;

		int n = *(int *)node->data;
		printf("%d ", n);
	}

	/* printf("\n"); */

	/* AWList_clear(list); */
	while ((node = AWList_iterator(list))) {
		printf("%d ", *(int *)node->data);
	}
	printf("\n");

	AWList_destroy(list);
}
